         DO ig=1,ngrid
          !! sensible heat flux in W/m2
!          hfx(ig) = zflubid(ig)-capcal(ig)*zdtsdif(ig)

! New SL parametrization, correct formulation for hfx :

          hfx(ig) = (pplay(ig,1)/(r*pt(ig,1)))*cpp
     &    *sqrt((pu(ig,1)*pu(ig,1) + pv(ig,1)*pv(ig,1)))
     &    *zcdh(ig)*(tsurf(ig)-zh(ig,1))

          !! u star in similarity theory in m/s
!          ust(ig) = 0.4
!     .               * sqrt( pu(ig,1)*pu(ig,1) + pv(ig,1)*pv(ig,1) )
!     .               / log( 1.E+0 + zzlay(ig,1)/z0_default )

! New SL parametrization, ust is more accurately computed in vdif_cd :
        ust(ig) = sqrt(zcdv(ig)*(pu(ig,1)*pu(ig,1) + pv(ig,1)*pv(ig,1)))

         ENDDO   
!         write (*,*) 'PHYS HFX cp zdts', hfx(100), zflubid(100), 
!     .       capcal(100), 
!     .       zdtsdif(100)
!         write (*,*) 'PHYS UST', ust(100) 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! LES LES 
       IF (flag_LES) THEN        

         write (*,*) '************************************************' 
         write (*,*) '** LES mode: the difv part is only used to'
         write (*,*) '**  provide HFX and UST to the dynamics'
         write (*,*) '** NB: - dudif, dvdif, dhdif, dqdif are set to 0'
         write (*,*) '**     - tsurf is updated'     
         write (*,*) '************************************************'

         DO ig=1,ngrid
          wmax_th(ig)=0.  !! no additional gustiness needed in surface layer (see vdifc.F)
          DO l=1,nlayer
            zdvdif(ig,l) = 0.
            zdudif(ig,l) = 0.
            zdhdif(ig,l) = 0.
            DO iq=1, nq
              zdqdif(ig,l,iq) = 0.
              zdqsdif(ig,iq) = 0. !! sortir de la boucle
            ENDDO 
          ENDDO
         ENDDO
      ENDIF
!!! LES LES        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
